﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.Windows.Controls;
using System.Windows;
using System.Windows.Input;
using System.Collections.ObjectModel;
using System.Collections;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Controls.Primitives;
using System.Windows.Media.Imaging;

namespace TreeViewMultiSelect.TreeView
{
    public class TreeViewControl : RadTreeView
    {
        private RadTreeViewItem deselectionRealTarget;

        public RadTreeViewItem DeselectionTarget
        {
            get 
            {
                return deselectionRealTarget;
            }
            set 
            {
                deselectionRealTarget = value;
            }
        }

        private RadTreeView rt;

        static TreeViewControl()
        {
            DefaultStyleKeyProperty.OverrideMetadata(typeof(TreeViewControl), new FrameworkPropertyMetadata(typeof(TreeViewControl)));
        }

        public TreeViewControl()
        {

        }

        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();

            rt = base.GetTemplateChild("mainList") as RadTreeView;
            if (rt != null)
            {
                rt.PreviewUnselected += new EventHandler<Telerik.Windows.RadRoutedEventArgs>(rt_PreviewUnselected);
                rt.PreviewMouseLeftButtonDown += new MouseButtonEventHandler(rt_PreviewMouseLeftButtonDown);
                rt.PreviewMouseLeftButtonUp += new MouseButtonEventHandler(rt_PreviewMouseLeftButtonUp);
            }
        }

        void rt_PreviewMouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            e.Handled = true;
        }

        void rt_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            var selectedTreeItem = (e.OriginalSource as UIElement).ParentOfType<RadTreeViewItem>();
            if (selectedTreeItem != null)
            {
                if (selectedTreeItem.IsSelected == true)
                {
                    deselectionRealTarget = (e.OriginalSource as UIElement).ParentOfType<RadTreeViewItem>();
                    this.Dispatcher.BeginInvoke(new Action(
                            delegate()
                            {
                                deselectionRealTarget.IsSelected = false;
                                deselectionRealTarget = null;
                            }
                    ));
                }
            }
        }

        private void rt_PreviewUnselected(object sender, Telerik.Windows.RadRoutedEventArgs e)
        {
            if (deselectionRealTarget == null)
            {
                var container = (e.Source as RadTreeView).SelectedContainer;

                e.Handled = true;
                return;
            }
         }

    }
}